/**********************************************************************
led.c                                              (mruganie diody LED)
                                                                       
Program powoduje mruganie diody LED podczonej do P1.16               
******************************************************* **************/
#include <LPC214x.H>       //zbir definiujcy rejestry mikrokontrolera
#include <INTTYPES.H>         //zbir definiujcy cakowite typy danych

#define NBit_LED 16                     // dioda LED sterowana birem 16
#define LED_init IO1DIR = IO1DIR  | (1 << NBit_LED)  // bit jako OUTPUT
#define LED_clr  IO1CLR = 1 << NBit_LED            // wyzeruj diod LED
#define LED_set  IO1SET = 1 << NBit_LED              // wcz diod LED

void delay(void);                       //prototyp funkcji opniajcej

//---------------------------------------------------------------------
int main (void) {
 LED_init;                          // port P1.16 ustawiony jako OUTPUT
                                                 //jako porty wyjciowe
 while(1){                                         //nieskoczona ptla
    delay();                           //wywoanie funkcji opniajcej
    LED_clr;                      //zapalenie diody podpitej pod P1.16
                                      //poprzez wstawienie zera na port
    delay();
    LED_set;                      //zgaszenie diody podpitej pod P1.16
                                   //poprzez wstawienie jedynki na port
 }
}

// podprogram opnienia czasowego ------------------------------------
void delay (void)  {                   //definicja funkcji opniajcej
  uint32_t i;   //deklaracja zmiennej, ktra posuy jako licznik ptli
  for(i = 0; i <= 0x100000; i++){};                //opnienie czasowe
}