/**********************************************************************
buzzer.c                       (sygna dwikowy wydawany przez buzzer)

Program generuje przerywany sygna dwikowy. Dwiki wydaje buzzer    
doczony do P0.25. Program wywouje podprogram opnienia czasowego   
delay.                                                                 
**********************************************************************/
#include <LPC214x.H>       //zbir definiujcy rejestry mikrokontrolera
#include <INTTYPES.H>         //zbir definiujcy cakowite typy danych

#define NBit_BUZ 25                        // buzzer sterowana birem 25
#define BUZ_init IO1DIR = 1 << NBit_BUZ  //bit portu dziaa jako OUTPUT
#define BUZ_clr  IO1CLR = 1 << NBit_BUZ               // wyzeruj buzzer
#define BUZ_mask 1 << NBit_BUZ                      //maska bitu buzzer

void delay(void);                        //prototyp funkcji opniajce

//---------------------------------------------------------------------
int main (void) {
 uint32_t sound;           // zmienna przybiera wartoci 0x00000000 lub
                                                       //... 0xFFFFFFFF
 BUZ_init;                          // port P0.25 ustawiony jako OUTPUT
                                                     
 while(1){                                         //nieskoczona ptla
    BUZ_clr;                                       // zerowanie bitu 25
    sound = ~sound;                                     //negacja bitw
    IO1SET = sound &  BUZ_mask ;                  //wycz buzzer P0.25
    delay();                                    
 }
}

// podrogram opnienia czsowego --------------------------------------
void delay (void)  {                   //definicja funkcji opniajcej
  uint32_t i;   //deklaracja zmiennej, ktra posuy jako licznik ptli
  for(i = 0; i <= 0x100000; i++){};                //opnienie czasowe
}