/**********************************************************************
IRQ2.c                   (dwa przerwania wektorowe - vector interrupts)
                                     
Program ilustruje dziaanie priorytetw przerwa wektorowych. rdem  
przerwa s przyciski podczone do linii EINT1 oraz EINT2.
Program gwny pokazuje na dwch diodach LED (OUTs) stany licznika   
binarnego.  Przycinicie przycisku podczonego do EINT1 powoduje 
mruganie 3 kolejnych diod LED, natomiast przycinicie przycisku 
podczonego do EINT2 spowoduje mruganie
3 skrajnie lewych diod LRD. Wyszy priorytet ma przerwanie EINT1
**********************************************************************/
#include <LPC214x.H>            // zbir definiujcy rejestry procesora
#include "GPIO.h"                // biblioteka funkcji obsugi diod LED
void delay(int);                               //prototyp funkcji delay
void EXTINT1VectoredIRQ(void) __irq;       // prototyp przerwania EINT1
void EXTINT2VectoredIRQ(void) __irq;       // prototyp przerwania EINT2

//--------------------------------- -----------------------------------
void main (void){
  char x=0;                   // zmienna przechowujca warto licznika
  PINSEL0 = 0xa0000000;             // ustawienie pinu P0.14 jako EINT1
                                           // ... oraz P0.15 jako EINT2
                                                
  // EXTMODE = 0x00000002;        // przerwanie EINT1 wyzwalane zboczem
  VICVectCntl0=0x0000002f; // przypisz 15 kana VIC(EINT1) do wektora 0
  VICVectAddr0=(unsigned)EXTINT1VectoredIRQ;      // przypisanie adresu
  VICVectCntl1=0x00000030; // przypisz 16 kana VIC(EINT2) do wektora 1
  VICVectAddr1=(unsigned)EXTINT2VectoredIRQ;      // przypisanie adresu
  VICIntEnable = 0x0018000;      // odblokowanie przerwa EINT1 i EINT2
  OUTs_init(0xff, 16);                            // inicjacja diod LED

  while(1){                                          // ptla bez koca
     delay(1);                                    // opnienie czasowe
     OUTs_put(x++,0x3,16);          // wywietlenie licznika na diodach
  }    
}
// podprogram opnienia ----------------------------------------------
void delay(int s){
  int i;
  for(i=0;i< (s * 0xfffff);i++);  
}

// podprogram obsugi przerwania EINT1 --------------------------------
void EXTINT1VectoredIRQ (void) __irq {
    static char x=0;          // zmienna przechowujca warto licznika
    delay(1);                                     // opnienie czasowe
    OUTs_put(x++,0x7,18);           // wywietlenie licznika na diodach

    EXTINT     = 0x00000002;              // zerowanie flagi przerwania
    VICVectAddr= 0x00000000;       // zerowanie Vector Address Register
}

// podprogram obsugi przerwania EINT2 --------------------------------
void EXTINT2VectoredIRQ (void) __irq {
    static char x=0;          // zmienna przechowujca warto licznika
    delay(1);                                     // opnienie czasowe
    OUTs_put(x++,0x7,21);           // wywietlenie licznika na diodach
    EXTINT     = 0x00000004;              // zerowanie flagi przerwania
    VICVectAddr= 0x00000000;       // zerowanie Vector Address Register
}