/**********************************************************************
 counter.c                                         (zliczanie impulsw)
 
 Program wykorzystujc Counter0 zlicza zdarzenia (zbocza rosnce)  
 na wejciu CAP0.0 (P0.2) i wynik wywietla na podczonych do portu
 P1.16 - 23 omiu diodach LED. 
**********************************************************************/
#include <LPC214x.H>            // zbir definiujcy rejestry procesora 

void main(void) {
  
  PINSEL0 = PINSEL0 | (1 << 5);                     // P0.2 -->  CAP0.0
  IODIR1  = 0x00FF0000;                       // P1.16..23 jako wyjcia

  T0TCR   = 0x00000002;              // zerowanie licznika i preskalera
                                      // (do momentu zdjcia tego bitu)
  T0MR0   = 256;              // wikszej liczby nie uda si wywietli
  T0MCR   = 0x00000002;           // zerowanie licznika gdy T0TC==T0MR0
  T0CTCR  = 0x00000001;           // TC zwikszany przy zboczu rosncym
                                         //... na wejciu CAP0.0 (P0.2)
  T0TCR   = 0x00000001;                         // wczenie licznika 0
  
  while (1) {
    IOCLR1 = ~T0TC << 16;                         // zgaszenie diod LED
    IOSET1 = T0TC << 16;                          // zapalenie diod LED
  }
}