/**********************************************************************
PWM_dual.c                                  (modulacja PWM: dwa zbocza)

Program steruje za pomoc ukadu PWM jasnoci  podczonej do 
wyjcia (P0.7) diody LED. Ukad PWM pracuje w  trybie kontroli 
obydwu zboczy (momentu pocztku i koca impulsu).
**********************************************************************/
#include <LPC213x.H>

int main(void) {
  unsigned int value, delay;

  PINSEL0 = PINSEL0 | (1<<15);                         // PWM2 --> P0.7

  PWMPCR = 0x00000404;       // kana 2 PWM praca z kontrol obu zboczy
  PWMMCR = 0x00000002;         // reset licznika PWMTC gdy rwny PWMMR0
  PWMMR0 = 0xFFFF;              // ustalenie okresu generowanych impulsw
  PWMMR1 = 1;                     // ustalenie momentu pocztku impulsu
  PWMMR2 = 0xFFFF-1;                     // ustalenie momentu koca impulsu
  PWMLER = 0x00000007;      // zlecenie uaktualnienia w nastpnym cyklu
                                 //... rejestrw PWMMR0 PWMMR1 i PWMMR2
  PWMTCR = 0x00000002;                  // reset licznika PWMTC i PWMPC
  PWMTCR = 0x00000009;                                 // wczenie PWM

  while(1) {            
    value = ++value & 0xFFFF;
    for(delay=0; delay < 256; delay++);        // niewielkie opnienie
    PWMMR1 = value;              // okrelenie momentu pocztku impulsu
    PWMMR2 = 0xFFFF-value;          // okrelenie momentu koca impulsu
    PWMLER = 0x00000006;    // zlecenie uaktualnienia w nastpnym cyklu
                                        //... rejestrw PWMMR1 i PWMMR2
  }
}