/**********************************************************************
ADC_interrupt.c                    (przetwornik AD w trybie przerwania)

Program pokazuje obsug przetwornika pracujcego w trybie 
przerwania. Dodatkowo wczony jest tryb automatycznych i cigych
pomiarw tzw. Tryb burst. Odczytana warto z wej AIN0.1...3 
(P0.28, P0.29,P0.30)) zapisywana jest do tablicy i wybrany kana
pomiarowy wywietlany jest na 8-miu diodach LED. Pomiary odbywaj si w
sposb cigy z rozdzielczoci 8-miu bitw.
**********************************************************************/
#include <lpc214x.h>

// obsuga przerwania przetwornika ADC --------------------------------
void AD_convers (void) __fiq {
  unsigned chan,val,x;
  unsigned result[4];                                // wyniki pomiarw
  val = ((AD0GDR>> (6+2)) & 0xFF);            //wyuskaj wynik 8-bitowy
  chan = ((AD0GDR >>24) & 0x07);                //wyuskaj numer kanau
  result[chan] = val;            //wpisz wynik przetwarzania do tablicy
  x=result[1];                      // zmie na result[2] lub result[3]
  x=(x<<16);
  IOCLR1 = x;          //wywietl wynik  z kanau AIN0.1 na diodach LED
  IOSET1 =~x;          
  VICIntEnable = 0x00040000;                         //wcz przerwania
  VICVectAddr  = 0x00000000;             //wyjcie z obsugi przerwania
}

//---------------------------------------------------------------------
int main(void){
  PINSEL1 = 1<<24 | 1<<26 | 1<<28;  // wybierz: AIN0.1, AIN0.2 i AIN0.3        
  AD0CR = 0x0025040e;	    // AD0: 10-bitw, Burst, AIN0.1...3, @ 3MHz
  IODIR1 = 0x00FF0000;          // P1.16..23 pracuj jako wyjcia (LED)
                  // domylna warto AD0INTEN=0x100 co dopowiada 0x101
  VICVectCntl0 = 0x32;     //pocz przerwanie 18 (0x12) ze szczelin 0
  VICVectAddr0 = (unsigned)AD_convers;                  //adres funkcji
                                           //...obsugujcej przerwanie
  VICIntEnable = 0x00040000;                         //wcz przerwania
  while(1);
}
