/*****************************************************************
sio_init.h      
Definicje przygotowujace do pracy transmisj szeregow.
*****************************************************************/
#ifndef _SIO_H
#define _SIO_H

#define SIO 0 // <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< 0,1 zmieni

#if SIO

// -------------------------                   inicjalizacja SI1: 
inline void SIO_init (void)  {
               PINSEL0 = 0x00050000;     //  Enable RxD1 and TxD1 
               U1LCR = 0x83;             //	                  8N1            
               U1DLL = 24;               //            38400 Baud
               U1LCR = 0x03;      
}

//--------------------------   nadawanie znaku poprzez zcze SIO 
 int putchar(int ch) {                
    do { } while (!(U1LSR & 0x20));       // czekanie na gotowo  
    return (U1THR = ch);                        // wysanie znaku 
}

 int _getkey(void) {
   do { } while (!(U1LSR & 0x01));
  return (U1RBR);                                 // odbir znaku
}  
#else //=========================================================

//-------------------------                    inicjalizacja SIO: 	    
inline void SIO_init (void)  {
               PINSEL0 = 0x00000005;      // Enable RxD1 and TxD1,
               U0LCR = 0x83;              //                  8N1  
               U0DLL = 24;                //           38400 Baud    
               U0LCR = 0x03;    
}

//--------------------------    nadawanie znaku poprzez zcze SIO 
 int putchar(int ch) {                
    do { } while (!(U0LSR & 0x20));        // czekanie na gotowo   
    return (U0THR = ch);                         // wysanie znaku 
}

//-------------------------        odbir znaku poprzez zcze SIO
 int _getkey(void) {
    do { } while (!(U0LSR & 0x01));        // czekanie na gotowo
    return (U0RBR);                                // odbir znaku
}  
#endif

#define SIO_INIT  SIO_init ()
#endif 	 // _SIO_H_ 

