// -----------------------------------------------------------------------
// Zbir : POWER.h
// Zbir zawiera definicje obsugi trybw ograniczonego poboru energii
// -----------------------------------------------------------------------

#ifndef _POWER_H_
#define _POWER_H_

#define PCTIM0	1
#define PCTIM1	2
#define PCUART0	3
#define PCUART1	4
#define PCPWM0	5
#define PCI2C0	7
#define PCSPI0	8
#define PCRTC	9
#define PCSPI1	10
#define PCAD0	12
#define PCI2C1	19
#define PCAD1	20

__inline void POWER_idle() {
	PCON |= 1;	
}

__inline void POWER_down() {
	PCON |= 2;	
}

__inline void POWER_periph_set(int periph, int state) {
	if(state) {
		PCONP |= 1 << periph;
		if(periph == PCAD0) {
			AD0CR |= 1 << 21;		// bit PDN w rejestrze ADC
		}
		if(periph == PCAD1) {
			AD1CR |= 1 << 21;		// bit PDN w rejestrze ADC
		}
	}
	else {
		if(periph == PCAD0) {
			AD0CR &= ~(1 << 21);	// bit PDN w rejestrze ADC
		}
		if(periph == PCAD1) {
			AD1CR &= ~(1 << 21);	// bit PDN w rejestrze ADC
		}
		PCONP |= 1 << periph;
	}
}

__inline char POWER_periph_get(int periph) {
	return (PCONP & (1 << periph)) >> periph;
}


#endif	// _POWER_H_ 
