// -----------------------------------------------------------------------
// zbir : LED.h
// Zbir zawiera definicje obsugi 8-bitowego zestawu diod LED
// -----------------------------------------------------------------------

#ifndef _LED_H_
#define _LED_H_

#include <lpc213x.h>

#define NBit_LED    16                        // przesunicie dla diod LED 
#define M           0xFF                        //maska dla 8-miu diod LED

#define LEDs_init IO1DIR = M << NBit_LED

//Polecenia sterujce LED ------------------------------------------------
#define LEDs_clr  IO1CLR = M << NBit_LED              // wyseruj diody LED
#define LEDs_set  IO1SET = M << NBit_LED                // wcz diody LED

__inline char  LEDs_get (void ) {	                          // stan diod LED
  return( (IO1PIN & ( M<< NBit_LED  ) ) >> NBit_LED) ;  
}                

__inline void LEDs_put(char x) {
  IO1CLR = ( ~x & M ) << NBit_LED ; 
  IO1SET = (  x & M ) << NBit_LED ; 
}

__inline void LED_clr(char n) {	                        // wyzeruj diod n
  IO1CLR = 1 << ( NBit_LED + (n) );
}   
__inline void LED_set(char n)  {	                          // wcz diod n
  IO1SET = 1 << ( NBit_LED + (n) );
}     
__inline char LED_get(char n) {
  return ( ( IO1PIN & (1 << ( NBit_LED + (n) ) ) )>> ( NBit_LED + (n) )  );
}

#endif // _LED_H_ 
