/*********************************************************************
WDT.c                    (przykad jak doda WATCHDOG WDT do programu)

Jest to modyfikacja programu sio.c po to aby pokaza jak uy ukadu
WATCHDOG. Po wczeniu program 3 razy zapala i gasi diod LED portu
P1. Na terminalu transmisji szeregowej pojawia si napis 
"Jak si masz ! Nacisnij cos...". Program czeka na nacinicie 
dowolnego klawisza na klawiaturze komputera. Nacinity znak pojawia 
si na terminalu. Program transmituje i odbiera znaki z parametrami:
               szybko 38400 bps, 
               8-N-1 (8-bitw, N- bez parzystoci, 1 bit stopu).
Wyniki dziaania s widoczne na terminalu transmisji szeregowej.
*********************************************************************/
#include <LPC214x.H>   
#include <stdio.h>
#include "inttypes.h"            // tu zdefiniowano BYTE, WORD i DWORD
#include "UART.h"

// pin LED_SEL jest sterowany poprzez port GPIO ----------------------
#define LED_SEL    1<<23                           // numer bitu P0.10
#define LED_set    IOSET1 =  LED_SEL
#define LED_clr    IOCLR1 =  LED_SEL
#define LED_init   IODIR1 |= LED_SEL

#define WDTkick   {WDFEED = 0xAA; WDFEED = 0x55;}     // aktywacja WDT

//--------------------------------------------------------------------
void main(void) {  
 DWORD i,k;
 char c;
 const char t[]="\n Jak sie masz !\n";  
  
 LED_init;

 for(k=0;k<3;k++) {
   for(i=0;i<0xfffff;i++);              
   LED_clr;                    // Po RESET 3x zapal diody LED portu P1
   for(i=0;i<0xfffff;i++);
   LED_set;                     // Po RESET 3x zga diody LED portu P1
 };
 
 WDTC  = 15000000/4 ;           // czas zadziaania WDT=1sek; (PCLK/4)
 WDMOD = 0x03;                             // reset i odblokowanie WDT
 WDTkick;                         // Start WDT - pierwsze uruchomienie

 UART_init;                                       // przygotowanie SIO
 while(1) {
    for (i=0;t[i];i++) putchar(t[i]);        // napis "Jak si masz !"
    puts(" Nacisnij cos...\n ");                                      
    c=_getkey();                                   // czekanie na znak
    putchar(c);               // odebrany znak pojawi si na terminalu
    printf("\n Odebrany znak ASCII:   %c (HEX:%02x DEC:%03u)", c,c,c);
 }
}

//--------------------------------- nadawanie znaku poprzez zcze SIO
int putchar(int ch) {                
    do { } while (!(U0LSR & 0x20));            // czekanie na gotowo
    return (U0THR = ch);                             // wysanie znaku
}

//------------------------------------ odbir znaku poprzez zcze SIO
 int _getkey(void) {
  do { /*WDTkick;*/ } while (!(U0LSR & 0x01)); // czekanie na gotowo
  return (U0RBR);                                      // odbir znaku
}