/*********************************************************************
I2C_engine_test.c              (obsuga I2C w systemie z przerwaniami)

Program pozwala przetestowa dziaanie kontrolera ukadu I2C procesora
LPC213x/4x w systemie przerwa. Program pokazuje zapis 1-bajtu danych 
do ukadu PCF8574 i nastpnie odczyt tego samego bajtu. Adres ukadu
PCF8574 do zapisu to 0x40. Adres do odczytu to 0x41. Poniewa 
zapisywany jest jeden bajt to zmienna  WR_NoBytes=1. Podobnie
RD_NoBytes=1. Do nadawania i odbioru danych suy ten sam bufor Buff.
*********************************************************************/
#include <LPC213x.H>
#include <stdio.h>
#include "inttypes.h"            // tu zdefiniowano BYTE, WORD i DWORD
#include "UART.h"                     // obsuga transmisji szeregowej
#include "i2c.h"                              // procedury obsugi I2C
                       
extern BYTE WR_NoBytes, RD_NoBytes, Buff[40];      // zmienne globalne
extern DWORD Fin;        // Fin > 0 oznacza zakoczenie transmisji I2C

void display(void);          // prototyp funkcji wywietlajcej wyniki
void delay(DWORD x);                             // opnienie czasowe

//--------------------------------------------------------------------
int main(){
  IODIR1 = 0xFF0000;        //piny P1.16...23 jako wyjcie (diody LED)
  UART_init;                                      // przygotowanie SIO
  printf("\n Test I2C \n");
  i2c_init();                                        //inicjowanie I2C
 
  Buff[0] = 0x40;               // polecenie: zapisz do ukadu PCF8574
  Buff[1] = 0xAA;            // zapisz 0xAA: co druga dioda LED wieci
  Buff[2] = 0x41;         // polecenie: odczytaj dane z ukadu PCF8574

  WR_NoBytes = 1;                           // zapisz 1 bajt (Buff[1])
  RD_NoBytes = 1;                         // odczytaj 1 bajt (Buff[3])
  i2c_engine();         // uruchom I2C (STA) i poczekaj na wynik (STO)
 
  while(1){     
     //Buff[1]++;        // zwikszanie danych przesyanych do PCF8574
     i2c_engine();      // uruchom I2C (STA) i poczekaj na wynik (STO)
     IOSET1 = 0xFF0000;  
     IOCLR1 = Buff[3] << 16;     // odebrane dane poka na diodach LED
     display();                            // wypisz wynik  ramk I2C
     //delay(0xfffff);                   // powolna obserwacja wynikw
  }
}

void display(void){ // wywietlanie ramki danych z I2C----------------
  BYTE i,k;
  k= (RD_NoBytes==0)?1:2;
  for(i=0;i<RD_NoBytes+WR_NoBytes+k;i++)   printf ("%02x ", Buff[i] );
  printf ("\r"); 
}

void delay(DWORD x) { // opnienie czasowe --------------------------
  DWORD i;
  for(i=0;i<x;i++);
}