/*********************************************************************
keyb_to_LCD_buff_mobile.c              (pobieranie danych z klawiatury
                      ...z buforowaniem, w stylu telefonu komrkowego)     

Program pozwala wprowadza dane z klawiatury z moliwoci kasowania
za pomoc klawisza backspace. Program pozwala zobaczy jak odbywa si
wprowadzanie tekstu z poprawianiem oraz jak dziaa wprowadzanie
dwch liczb typu float po to aby je doda do siebie.
Aby przej do pisania kolejnego znaku trzeba nacisn klawisz TAB.
W programie uywa si funkcji sscanf z biblioteki stdio.h.
*********************************************************************/
#include <LPC214x.H>                      //zbir definiujcy rejestry
#include <stdio.h>
#include "inttypes.h"            // tu zdefiniowano BYTE, WORD i DWORD
#include "LCD4bit.h"                                
#include "KEYB.h"                     // biblioteka funkcji klawiatury       
                                   //... mona take wyprbowa UART.h
 
#define CharNo   NB_COL+1        // NB_COL liczba znakw w wierszu LCD

void getline (char *line_buf, BYTE n);           // prototyp procedury
                                           //... pobrania linii tekstu
char line_buf[CharNo];                        // bufor na lini tekstu
//--------------------------------------------------------------------
void main(void) {
  char t[CharNo];                                            // string
  float f,g;                                      // dwie liczby float
                                
   KEYB_init;                         // przygotowanie klawiatury KEYB
   LCD_init;                                      // przygotowanie LCD
   printf("\nLine Buffer-----"); 
    
cont: 
   putchar('\n');                           
   getline(line_buf, CharNo);               // pobieranie linii tekstu

   sscanf(line_buf,"%s", t );      // interpretacja danych jako string
   printf("\nStr:%s",t); 

   //sscanf(line_buf,"%f %f", &f,&g);     // interpretacja danych jako
   //printf("\n+= %12.3g",f+g);                  //...dwie liczy float
   goto  cont;                        // mao eleganckie ale skuteczne
}

//--------------------------------------------------------------------                                                                      
// Pobranie jednej linii tekstu z moliwoci edycji znakw               
//------------------------------------------------------------------- 
void getline (char  *line_buf, BYTE n)  {
  char c,pp,nn;             // pp - poprzedni znak ; nn -nastpny znak
  BYTE cnt = 0 , indx;  // indx= liczba nacini tego samego klawisza

  do  {
    c = _getkey ();                                  // pobranie znaku
    pp=nn;   
    nn=c;
    if(c=='\n') c='\r';

//################### obsuga klawiatury podobna jak w tel. komrkowym               
    if (c <=0x39 && c>=0x30 && c== pp ) {          //znaki ASCII: 0..9
     if (cnt > 0 )  {   
        cnt--;                         // zmniejszenie licznika znakw
        line_buf--;          // zmniejszenie wskanika biecego znaku        
        putchar ('\b');               // wyprowadzenie znaku backspace
     }
     if (c==0x31) { c= indx==0 ? '1': 
                                   indx==1 ? ' ':indx==2 ? '+':'-' ; }
     else if (c==0x30) { c= indx==0 ? '0':
                                  indx==1 ? '.':indx==2 ? 'e':'\r' ; }
     else  { c= indx==0 ? c: 0x40 + ((c & 0x0F) -2)*3+indx;}
     indx= (indx+1) & 0x03;
   }
   else  indx=0; 
//##############################################  koniec dodanej opcji

   if (c == '\t' ) {
        putchar (' ');                // wyprowadzenie znaku backspace
        putchar ('\b');
   }
   else
   if (c == '\b' )  {                       // obsuga znakw bakspace
      if (cnt > 0)  {            
        cnt--;                         // zmniejszenie licznika znakw
        line_buf--;          // zmniejszenie wskanika biecego znaku
        putchar ('\b');               // wyprowadzenie znaku backspace
        putchar (' ');
        putchar ('\b'); 
     }
   }
   else  {                                   
      putchar (*line_buf = c);       // echo znaku i skadowanie znaku
      line_buf++;              // zwikszenie wskanika znakw w linii
      cnt++;                            // zwikszenie licznika znakw
   }
  }  while (cnt < n - 1  &&  c != '\r');  // sprawdzenie limitu znakw
  *line_buf = 0;           // znak 0 (NULL) jest ogranicznikiem znakw
} 