/*--------------------------------------------------------------------
MMC.H                             (prototypy funkcji obsugi katy MMC)

Zbir definicji i funkcji umoliwiajcych obsug karty MMC. 
Przedstawione funkcje to inicjowanie, zapis i odczyt bloku 512 bajtw 
danych oraz cigy odczyt bloku o dugoci jednego bajtu.
Przedstawione funkcje nie wyczerpuj zagadnienia obsugi MMC i maj 
jedynie charakter przykadowy
--------------------------------------------------------------------*/
#ifndef __MMC_H__
#define __MMC_H__

// pin SSEL1 jest sterowany poprzez port GPIO ------------------------
#define SPI_SEL      1<<20                           
#define SSEL1_SET    IOSET0 = SPI_SEL
#define SSEL1_CLR    IOCLR0 = SPI_SEL

// makrodefinicja zamieniajca liczb 32 bitow na bajty (offset) ----
#define GET_BYTE(val,offset)  *(((BYTE *) &(val))+ (offset))

// prototypy funkcji do obsugi kary MMC -----------------------------
int MMC_Init(void);
int MMC_RD_multBl_start(DWORD data_address);
int MMC_RD_multBl_cont(BYTE *result);
int MMC_RD_multBl_fin(void);
int MMC_set_block_length(DWORD block_length);
int MMC_RD_block(DWORD block_number, BYTE *MMCRDData);
int MMC_WR_block(DWORD block_number, BYTE *MMCWRData);

#endif // __MMC_H__
   