/*********************************************************************
 MMC_play.c                       (odtwarzanie zbioru WAV z karty MMC)

Program odczytuje dane z karty multimedialnej MMC i przesya je do 
przetwornika AD procesora '214x. W przedstawionym przykadzie 
odtwarzany jest zbir w formacie WAV, monofoniczny, 8-bitowe prbki, 
czstotliwo prbkowania 8kHz, po ominiciu nagwka zbioru. Program 
po zainicjowaniu karty MMC dokonuj odczytu cigego blokw danych z 
karty MMC. Kady z odebranych blokw ma dugo 1-bajt danych. 
Zakoczenie odbioru wymaga wysania do karty 
polecenia koczcego Finish.
*********************************************************************/
#include <LPC214x.H>   
#include <stdio.H>
#include "inttypes.h"            // tu zdefiniowano BYTE, WORD i DWORD
#include "spi.h"
#include "mmc.h"
#include "uart.h"

#define BLOCK_START  0x208<<9  // pierwszy sektor danych na karcie 32MB
#define BLOCK_END    0x228<<9              // koniec bloku danych (wav)
#define BLOCK_SIZE   1 
void message (const char *message, BYTE Status);
BYTE Status;
//---------------------------------------------------------------------
void main (void) {
     DWORD i, delay, BlockIndex = 0;
     BYTE MMCRDData;                             // odebrane dane z MMC
start:
     UART_init; 
     PINSEL1 |= 1<<19;                            // wybierz DAC (AOUT)
     SPI_Init();                                     // inicjowanie SPI
     printf("MMC Audio play Demo ---------------------------------\n");

     if ( MMC_Init() )                                
          message("INIT/Config Error\n",0);          // inicjowanie MMC
    //goto start;         // inicjowanie mona zobaczy na oscyloskopie

     if ( MMC_set_block_length(1) ) 
          message("Set Block Length Error\n",0); // blok odczytu: 1bajt

     if ( MMC_RD_multBl_start(BLOCK_START))
          message("Start Multile Block Read: Error\n",0); //multi-block

     for ( BlockIndex = BLOCK_START; 1 ; BlockIndex++ ) {

           if( MMC_RD_multBl_cont(&MMCRDData) )
               message("Continue Multiple Block Read: Error\n",Status);          

           // printf("%02x ", MMCRDData  );        // drukowanie danych
           // if ( (i++ %16) ==15)     printf("\n");  //... po 16 batw

           DACR= (DWORD)MMCRDData <<8;               // prbki 8-bitowe
           for (delay=0;delay<0x160;delay++);  // opnienie dla f=8KHz 
		 if (BlockIndex>=BLOCK_END )  
		   if (MMC_RD_multBl_fin())message("Finish Error\n",0);             
         			                    // else goto start;
					   else break;
     }
     message("end ------------\n",0);
}

// ------------------------------------ drukowanie komunikatu o bdzie
void message (const char *message, BYTE Status) {
    if(Status !=0) printf(" Status %d\n", Status);
    printf(message);
    while ( 1 );                                                 //stop        
}