/*********************************************************************
ARP_scan.c                                 (skaner ARP: test Ethernet)

Program pozwala przetestowa dziaanie kontrolera Ethernet typu
RTL8019AS. Pozwala na wysyanie i odbir ramek przez kontroler MAC 
(Media Access Control). Program wysya ramki rozgoszeniowe ARP i
oczekuje na zwrotn odpowied zawierajc adres urzdzenia MAC. Majc
adres internetowy IP poszukuje si adresu urzdzenia MAC. Dla zadanego
adresu IP przeszukuje si sie w poszukiwaniu 16-urzdze o adresach 
IP od x.x.x.0 do x.x.x.15. Odebrana ramka informacji poprzedzona jest 
nagwkiem dopisywanym przez kontroler RTL w postaci czterech bajtw.
*********************************************************************/
#include <LPC214x.H>       
#include <stdio.h>
#include "inttypes.h"            // tu zdefiniowano BYTE, WORD i DWORD
#include "UART.h"
#include "RTLregs.h"                             // rejestry RTL8019AS
#include "RTL.h"           // podstawowe procedury nadawania i odbioru
#include "RTLhardware.h"   // podczenie RTL8019AS do procesora '214x

BYTE ARP[28] = { // budowa ramki ARP ---------------------------------
     00,01,                                                // hardware
     0x08,00,                                              // ramka IP
     06,                                           // dugo MAC addr
     04,                                            // dugo IP addr
     00,01,                         // ARP request: danie adresu MAC
     01,02,03,04,05,06,                       // my MAC: mj adres MAC
     10,00,00,100,                              // my IP: mj adres IP
     0xff,0xff,0xff,0xff,0xff,0xff,        // broadcast: do wszystkich
     10,0,0,4,            // target IP for resolve: szukamy MAC dla IP
};

//--------------------------------------------------------------------
void main(void) { 
  BYTE x,cnt = 0;
  WORD len=68;                    // liczba odebranych bajtw z bufora
  BYTE i, frame[68];

  UART_init;                                      // przygotowanie SIO
  printf("\n Ethernet ARP scanner\n get IP=") ; 
  Delay_us(4000000L);
  if( (IO0PIN & (1<<14)) )	goto skip;
  for (i=0; i<4; i++ ) {
     scanf("%u", &x);    // podaj adres IP do skanowania, np. 10 0 0 0
     ARP[i+24]=x;
  }
skip:            
  if (NICInit()) printf("\n NIC Reset Failed");                // bd

  while (1) {
    Delay_us(1000000);
    cnt= (cnt+1) & 0x0f;
    printf("\n ARP Ask %u.%u.%u.%u ",ARP[24],ARP[25],ARP[26],ARP[27]+cnt);
    NICSend(ARP[27]+cnt);                                // wysanie ramki ARP
    if (NICReceive(len, frame) == 0 ) {    // czekanie na odbir ramki
        printf("\n\n Received MAC:  ");  
        for (i=0; i<6; i++ ) printf(" %02x:",frame[i+10]);
        printf("\n");
        for (i=0; i<len; i++ ) {  // ramka w buforze wraz z nagwkiem
             printf(" %02x",frame[i] ) ;  
             if((i%16)==15) printf("\n");
       }
       printf("\n");
   }
  }
}