/**********************************************************************
fiq.c                             (szybkie przerwanie - fast interrupt)
      
Program ilustruje uycie przerwania zewntrznego wyzwalanego poziomem. 
Program gwny pokazuje na trzech diodach LED (OUTs) stany licznika   
binarnego. Przycinicie przycisku przerwania powoduje mruganie   
czterech innych diod LED tak dugo dopki przycinity jest przycisk 
przerwania.
**********************************************************************/
#include <LPC214x.H>             //zbir definiujcy rejestry procesora
#include "GPIO.h"           //biblioteka funkcji sterowania diodami OUT

void delay(int s);                             //prototyp funkcji delay

//podprogram obslugi przerwania ---------------------------------------
void FIQ_Handler (void) __irq {
   static char x=0x00;         //zmienna przechowujca warto licznika
   delay(1);                                       //opnienie czasowe
   OUTs_put(x++,0xf,20);         // wywietlenie zawartoci licznika na
                       //... diodach LED: 0xF- maska, 20 - przesunicie
    
   EXTINT= 0x00000002;                   //wyzerowanie flagi przerwania
}

//----------------------------- ---------------------------------------
int main(void) { 
  char x=0x00;                // zmienna przechowujca warto licznika
  PINSEL0     = 0x20000000;         // ustawienie pinu P0.14 jako EINT1
  VICIntSelect= 0x00008000;       // ustaw 15 kana VIC(EINT1) jako FIQ
  VICIntEnable= 0x00008000;            // odblokowanie przerwania EINT1
  OUTs_init(0xff, 16);                      //inicjacja diod LED (OUTs)


  while (1) {                                        // ptla bez koca
     delay(1);                                    // opnienie czasowe
     OUTs_put(x++,0x7,16);       // wywietlenie zawartoci licznika na
                      //... diodach LED: 0x7 - maska, 16 - przesunicie                                  
  }                                                                    
}

//podprogram opnienia w sek.-----------------------------------------
void delay(int s) {
  int i;
  for(i=0;i< (s * 0xfffff);i++);
}  



