/**********************************************************************
IRQ.c                         (przerwanie wektorowe - vector interrupt)
                                      
Program ilustruje uycie przerwa wektorowych. rdem przerwa jest
przycisk podczony do linii EINT1.     
Program ilustruje uycie przerwania zewntrznego wyzwalanego poziomem.  
Program gwny pokazuje na czterech diodach LED (OUTs) stany licznika   
binarnego. Przycinicie przycisku przerwania powoduje mruganie   
czterech innych diod LED tak dugo dopki przycinity jest przycisk 
przerwania.
**********************************************************************/
#include <LPC214x.H>            // zbir definiujcy rejestry procesora
#include "GPIO.h"                // biblioteka funkcji obsugi diod LED
void delay(int);                              // prototyp funkcji delay
void EXTINTVectoredIRQ  (void) __irq ;     // prototyp obsugi przerwa

//---------------------------------------------------------------------
int main (void){
  char x=0x00;                // zmienna przechowujca warto licznika
  PINSEL0 = 0x20000000;             // ustawienie pinu p0.14 jako EINT1
  VICVectCntl0=0x0000002f; // przypisz 15 kana VIC(EINT1) do wektora 0
  VICVectAddr0=(unsigned)EXTINTVectoredIRQ;       // przypisanie adresu
  VICIntEnable = 0x0008000;            // odblokowanie przerwania EINT1
  OUTs_init(0xff, 16);                             //inicjacja diod LED

  while(1){                                           //ptla bez koca
     delay(1);                                     //opnienie czasowe
     OUTs_put(x--,0xf,16);     // wywietlenie  licznika na diodach LED
  }    
}

// podprogram opnienia-----------------------------------------------
void delay(int s){
  int i;
  for(i=0;i< (s* 0xfffff);i++);  
}
// podprogram obsugi przerwania---------------------------------------
void EXTINTVectoredIRQ  (void)  __irq {
  static char x;              // zmienna przechowujca warto licznika
  delay(1);                                        //opnienie czasowe
  OUTs_put(x++,0xf,20);         // wywietlenie licznika na diodach LED
  EXTINT= 0x00000002;                    //wyzerowanie flagi przerwania
  VICVectAddr=0x00000000;         //wyzerowanie Vector Address Register
}
