/**********************************************************************
PWM_single.c                              (modulacja PWM: jedno zbocze)

Program steruje za pomoc ukadu PWM jasnoci 
podczonej do jego wyjcia (P0.7) diody LED. Ukad PWM pracuje w
trybie kontroli pojedynczego zbocza (momentu koca impulsu).
**********************************************************************/
#include <LPC214x.H>

main(void) {
  unsigned int value, delay;

  PINSEL0 = PINSEL0 | (1<<15);                        //  PWM2 --> P0.7

  PWMPCR = 0x00000400;                  // kana 2 PWM praca z kontrol
                                              //... pojedynczego zbocza
  PWMMCR = 0x00000002;         // reset licznika PWMTC gdy rwny PWMMR0
  PWMMR0 = 0xFFFF;            // ustalenie okresu generowanych impulsw
  PWMMR2 = 1;                        // ustalenie momentu koca impulsu
  PWMLER = 0x00000005;      // zlecenie uaktualnienia w nastpnym cyklu
                                        //... rejestrw PWMMR0 i PWMMR2
  PWMTCR = 0x00000002;                 // reset licznikw PWMTC i PWMPC
  PWMTCR = 0x00000009;                   // zezwolenie na dziaanie PWM

  while(1) {            
    value = ++value & 0x00000FFFF;
    for(delay=0; delay < 0xFF; delay++); 
    PWMMR2 = value;                 // okrelenie momentu koca impulsu
    PWMLER = 0x00000004;    // zlecenie uaktualnienia w nastpnym cyklu
                                                  //... rejestru PWMMR2
  }
}
