/*--------------------------------------------------------------------------
INTTYPES.H

Standard ISO C typedefs for fixed size integral types 
Copyright (c) 2004 Keil Elektronik GmbH, and Keil Software, Inc.
All rights reserved.

MISRA-C also requires the use of typedefs for integer types.
MISRA-C1 Rules 13 and 14
MISRA-C2 Rules 6.1, 6.2, 6.3
--------------------------------------------------------------------------*/

#ifndef __INTTYPES_H__
#define __INTTYPES_H__

/* This type should be used for characters  (MISRA-C2 6.1)*/
typedef    unsigned  char char_t;

/* integer types (MISRA-C2 6.2, 6.3 */
typedef      signed  char        int8_t;
typedef    unsigned  char        uint8_t;
typedef    unsigned  char        BYTE;

typedef      signed  short       int16_t;
typedef    unsigned  short       uint16_t;
typedef    unsigned  short       WORD;

typedef      signed  int         int32_t;
typedef    unsigned  int         uint32_t;
typedef    unsigned  int         DWORD;

typedef      signed  long long   int64_t;
typedef    unsigned  long long   unit64_t;

#endif
