/*********************************************************************
spi0_hard.c                                     (ukadowa obsuga SPI)

Biblioteka moduw obsugi SPI metod ukadow w procesorach '214x.
Kady z podprogramw jednoczenie zapisuje i odczytuje dane. Modu
SPI_Byte - nadaje i odbiera bajt danych
SPI_Data - nadaje i odbiera cig bajtw.
*********************************************************************/
#include <LPC214X.H> 
#include "inttypes.h"            // tu zdefiniowano BYTE, WORD i DWORD

//-------------------------------------------------- inicjalizacja SPI
void SPI_Init(void) {
  PINSEL0 |=0x1500;                        // przygotowanie pinw SPI0
  S0SPCCR=15;        // podzielnik PCLK; dla 15MHz wynik jest SCK=1MHz
  S0SPCR=0x20;                           // CPHA=0, CPLO=0. SPI Master
}

//--------------------- podprogram nadawania i odbioru bajtu przez SPI
BYTE SPI_Byte(BYTE tx_byte) {
  S0SPDR=tx_byte;                       // wysanie bajtu do nadawania
  do { } while ( !(S0SPSR  & 0x80) );     // sprawdzanie koca odbioru
  return S0SPDR;                           // odczyt odebranych danych
}

// ------------- Podprogram nadawania i odbioru cigu bajtw przez SPI
void SPI_Data( BYTE *receive,BYTE *send, WORD Length ) {
  DWORD i;
  BYTE  *tmp = receive;
  for ( i = 0; i < Length; i++ ) {
    if(send==0)     *(receive++) = SPI_Byte(0xFF);     // tylko odczyt
    if(receive==0)  SPI_Byte(*(send++));            // tylko nadawanie
    if ( (send !=0) &&  (receive!=0)) 
                                   *(receive++) = SPI_Byte(*(send++));
  }
  receive=tmp;      // ustaw wskanik na pocztek odebranej informacji
  return;
}
