/*********************************************************************
Try_mtime.c                 (testowanie moduu mtime z systemu LINUX)

Program zegara odmierzajcego czas liczony w sekundach. Jest to czas
uniwersalny liczony od 01/01/1970 roku. Dla jego przechowywania 
wystarczaj tylko 4-bajty (DWORD). Czas ten jednoznacznie wyznacza
dzie, miesic, rok oraz godziny, minuty i sekundy, a take dzie 
tygodnia. Program w przedstawionej wersji zwiksza czas
o jeden cay dzie plus 1 sekunda. Daje to moliwo udowodnienia 
poprawnoci dziaania wszystkich procedur zegara i kalendarza.
Program transmituje znaki przez zcze UART parametrami:
38400 bps (8-N-1). Przedstawiony program jest prezentacj procedur 
zamiany struktury TM opisujcej czas na sekundy od roku 1970 i 
odwrotnie. Aby uzyska dokadnie dziaajcy program zegara/kalendarza
naley zastpi instrukcj opnienia w wierszu #44 dokadn 
procedur odliczania czasu co 1 sek.
*********************************************************************/
#include <LPC214x.H>   
#include <stdio.H>
#include "inttypes.h"            // tu zdefiniowano BYTE, WORD i DWORD
#include "uart.h"
#include "mtime.h"

DWORD Sec_since1970;           // tu zliczane s sekundy od 1/01/1970
TM  TIME;                      // struktura przechowujca Dat i Czas

//------------------------------------------------ -------------------
main(void) { 
  char string[40];
  DWORD i;       
  UART_init;                                      // przygotowanie SIO
  printf("\nLINUX TIME test:");
        
  TIME.TM_dom=8;                                // day-of-month 1...31
  TIME.TM_month=12 ;                                // miesic: 1...12
  TIME.TM_year=2006;                               // rok: 1970...2038
                           
  TIME.TM_hour=23;                                     // godz.:0...23
  TIME.TM_min=59;                                       // min.:0...59
  TIME.TM_sec=40;                                       // sek.:0...59
  printf("\n Linux TIME Test ------------------------------------\n");    
  Sec_since1970=TM_to_sec( &TIME );           // zamiana TM na sekundy
  printf("\n sec since 1.1.1970 %ld =\n",Sec_since1970 );  // pocztek
  while (1){                        // drukowanie wynikw co ok. 1sek.
    for( i=0;i<0x4fffff;i++ );                           // opnienie
    //Sec_since1970 ++;                     // zwiksz liczb sek. O 1
                           // zwiksz liczb sek. o cay dzie + 1sek.
    Sec_since1970 += 60*60*24L +1 ;     // ... dla testowania programu

    sec_to_TM(Sec_since1970,&TIME);   // zamiana sek.-> Dat i Czas TM
    TM_to_string(&TIME,string);    // zamiana Daty i Czasu TM na ASCII
    printf("\r %s",string);                // drukowanie stringu ASCII

    printf("  = %d",Sec_since1970 - TM_to_sec(&TIME) );  // porwnanie                               
  }
}
